SystemOrganization addCategory: #'Magritte-CustomBuilder'!

!Behavior methodsFor: '*magritte-custombuilder' stamp: 'kph 8/18/2007 02:35'!
allSelectorsBelow: topClass 
	| coll |
	coll := OrderedCollection new.
	self withAllSuperclasses do: 
			[:aClass | 
			aClass = topClass ifTrue: [^ coll asIdentitySet ] ifFalse: [coll addAll: aClass selectors]]! !

!MANamedBuilder methodsFor: '*magritte-custombuilder-override' stamp: 'kph 8/19/2007 01:21'!
build: anObject
	| selectors container description |
	
	selectors := (anObject class allSelectorsBelow: ProtoObject class) select: [ :each | each isDescriptionSelector ].
	container := self build: anObject for: self containerSelector in: selectors.
	^ (selectors select: [ :each | each isDescriptionDefinition ])
		inject: (cache at: anObject put: container)
		into: [ :result :each |
			self containerSelector = each ifFalse: [
				description := self build: anObject for: each in: selectors.
				description isDescription
					ifTrue: [ result add: description ] ].
			result ]! !

MADescriptionBuilder subclass: #MACustomDescriptionBuilder
	instanceVariableNames: 'prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-CustomBuilder'!

MACustomDescriptionBuilder class
	instanceVariableNames: 'defaults'!

MACustomDescriptionBuilder class
	instanceVariableNames: 'defaults'!

!MACustomDescriptionBuilder class methodsFor: 'as yet unclassified' stamp: 'kph 8/18/2007 02:08'!
defaults

	^ defaults ifNil: [ defaults := IdentityDictionary new ]! !

!MACustomDescriptionBuilder class methodsFor: 'as yet unclassified' stamp: 'kph 8/18/2007 02:10'!
prefix: aPrefixSymbol 
	^ self defaults at: aPrefixSymbol
		ifAbsentPut: 
			[(self basicNew)
				setPrefix: aPrefixSymbol;
				initialize;
				yourself]! !

!MACustomDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 8/19/2007 01:25'!
build: anObject
	| selectors container description |
	selectors := (anObject class allSelectorsBelow: ProtoObject class) select: [ :each | self isThisOurs: each ].
	container := self build: anObject for: self containerSelector in: selectors.
	^ (selectors select: [ :each | self isThisOneOfOurDefinitions: each ])
		inject: (cache at: anObject put: container)
		into: [ :result :each |
			self containerSelector = each ifFalse: [
				description := self build: anObject for: each in: selectors.
				description isDescription
					ifTrue: [ result add: description ] ].
			result ]! !

!MACustomDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 8/18/2007 02:17'!
build: anObject for: aSelector in: aCollection
	^ (aCollection select: [ :each | self isThis: each anExtensionOf: aSelector ])
		inject: (anObject perform: aSelector)
		into: [ :result :each | anObject perform: each with: result ]! !

!MACustomDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 8/18/2007 01:50'!
containerSelector
	^ #descriptionContainer! !

!MACustomDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 8/18/2007 02:16'!
isThis: selector anExtensionOf: orig

	"Answer whether the receiver is a method selector following the naming conventions of a 'custom' description extension to aSelector."

	^ (self isThisOurs: selector)
		and: [ selector numArgs = 1
		and: [ selector beginsWith: orig ] ]! !

!MACustomDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 8/18/2007 02:22'!
isThisOneOfOurDefinitions: selector 
	"Answer wheter the receiver is a method selector following the naming conventions of a description definition."

	^ (self isThisOurs: selector)
		and: [ selector isUnary ]! !

!MACustomDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 8/18/2007 02:14'!
isThisOurs: selector 

	"Answer wheter the receiver is a method selector following the naming conventions of a  our 'custom' description selector."

	^ selector ~= prefix and: [ selector beginsWith: prefix ]! !

!MACustomDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 8/18/2007 02:10'!
setPrefix: aPrefix

 prefix := aPrefix! !
